# Copyright 2011, Architect Francis Mc Shane RIBA
# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name        :   StairFMS2
# Description :   A tool to create a simple stair.
# Menu Item   :   Draw
# Usage       :   Specify the stair dimensions and number of steps in a dialog box.
#             :   Change location and rotation after inserting into the model. 
#             :   Each step is a component so change 1 to change all.
# Date        :   23 May 2011
#-----------------------------------------------------------------------------

# Standard Google SketchUp API utility.
require 'sketchup.rb'

# the following defines the method draw_stairs
    def draw_stairs

    prompts = [$exStrings.GetString("number_of_stairs"), $exStrings.GetString("width"), $exStrings.GetString("rise"),$exStrings.GetString("run"), $exStrings.GetString("thickness_of_step")]
      values = [10, 3.feet, 0.75.feet, 1.feet, 0.75.feet]
      results = inputbox prompts, values, $exStrings.GetString("Stair Dimensions")
      number_of_stairs, width, rise, run, thickness_of_step = results

       #  model and the Entities collection it contains.
       model = Sketchup.active_model
       model.start_operation $exStrings.GetString("draw_stairs") # one click undo
       entities = model.active_entities
       group = entities.add_group
       entities = group.entities

    for step in 1..number_of_stairs
       
       x1 = 0
       x2 = width
       y1 = run * step
       y2 = run * (step + 1)
       z = rise * step    
       # Create a series of "points", each a 3-item array containing x, y, and z.
       pt1 = [x1, y1, z]
       pt2 = [x2, y1, z]
       pt3 = [x2, y2, z]
       pt4 = [x1, y2, z]
       # Create the step.
       new_face = entities.add_face pt1, pt2, pt3, pt4
       new_face.pushpull -thickness_of_step

     end #for loop

  model.commit_operation
 
  end # draw_stairs


#=============================================================================

# Add a menu called StairsFMS1
if( not file_loaded?("StairsFMS1.rb") )
  add_separator_to_menu("Draw")
# call the draw_step method when you click on StairsFMS1 in the Draw menu
    UI.menu("Draw").add_item("StairsFMS1") { draw_stairs }
    
    file_loaded("StairsFMS1.rb")
end

